package repository

import (
	"github.com/google/uuid"
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/bimbingan_log/entity"
	"gorm.io/gorm"
)

type BerkasRepo struct {
	DBWrite *gorm.DB
	DBRead  *gorm.DB
}

func NewBerkasRepository(dbWrite *gorm.DB, dbRead *gorm.DB) *BerkasRepo {
	return &BerkasRepo{
		DBWrite: dbWrite,
		DBRead:  dbRead,
	}
}

func (repo *BerkasRepo) NewBatchBerkas(bimbinganLogId string, berkas []entity.Berkas) (output []entity.Berkas, err error) {
	if len(berkas) == 0 {
		return []entity.Berkas{}, nil
	}

	for i := range berkas {
		berkas[i].ID = uuid.New().String()
		berkas[i].IDBimbinganLog = bimbinganLogId
	}

	result := repo.DBWrite.Create(&berkas)
	if result.Error != nil {
		return nil, result.Error
	}
	return berkas, nil
}

func (repo *BerkasRepo) GetBerkasByLogID(idBimbinganLog string) (output []entity.Berkas, err error) {
	var berkas []entity.Berkas
	result := repo.DBRead.Where("id_bimbingan_log = ?", idBimbinganLog).Find(&berkas)
	if result.Error != nil {
		return nil, result.Error
	}
	return berkas, nil
}
