package entity

import (
	"time"
)

// type pendaftaran_ta_status_enum string

// const (
// 	NOT_ASSIGNED pendaftaran_ta_status_enum = "NOT_ASSIGNED"
// 	INTERVIEW    pendaftaran_ta_status_enum = "INTERVIEW"
// 	APPROVED     pendaftaran_ta_status_enum = "APPROVED"
// 	REJECTED     pendaftaran_ta_status_enum = "REJECTED"
// )

type DataTopik struct {
	Id        string `json:"id"`
	Judul     string `json:"judul"`
	Deskripsi string `json:"deskripsi"`
	IdPengaju string `json:"id_pengaju"`
}

type DashboardMahasiswaRet struct {
	Mahasiswa           DataMahasiswa       `json:"mahasiswa"`
	StatusPendaftaranTA StatusPendaftaranTA `json:"pendaftaran_ta"`
	DosenBimbingan      DataDosenBimbingan  `json:"dosen_bimbingan"`
	LogBimbingan        []LogBimbingan      `json:"bimbingan"`
	Seminar             SidangSeminar       `json:"seminar"`
	Sidang              SidangSeminar       `json:"sidang"`
}

type DataMahasiswa struct {
	IdMahasiswa string `json:"id"`
	Nama        string `json:"nama"`
	Email       string `json:"email"`
	NIM         string `json:"nim"`
}

type StatusPendaftaranTA struct {
	Id              string    `json:"id"`
	JalurPilihan    string    `json:"jalur_pilihan"`
	WaktuPengiriman time.Time `json:"waktu_pengiriman"`
	JadwalInterview time.Time `json:"jadwal_interview"`
	WaktuKeputusan  time.Time `json:"waktu_keputusan"`
	Status          string    `json:"status"`
	Topik           DataTopik `json:"topik"`
}

type DataDosenBimbingan struct {
	IdDosen string `json:"id"`
	Nama    string `json:"nama"`
	Email   string `json:"email"`
}

type LogBimbingan struct {
	Id              string               `json:"id"`
	WaktuBimbingan  time.Time            `json:"waktu_bimbingan"`
	LaporanKemajuan string               `json:"laporan_kemajuan"`
	Todo            string               `json:"todo"`
	NextBimbingan   string               `json:"next_bimbingan"`
	Status          bool                 `json:"status"`
	Berkas          []BerkasLogBimbingan `json:"berkas"`
}

type BerkasLogBimbingan struct {
	Id   string `json:"id"`
	Nama string `json:"nama"`
	Link string `json:"link"`
}

type SidangSeminar struct {
	Id         string    `json:"id"`
	Ditolak    bool      `json:"ditolak"`
	Lulus      bool      `json:"lulus"`
	WaktuMulai time.Time `json:"jadwal_seminar"`
	Ruangan    string    `json:"ruangan"`
}
