package usecase

import "gitlab.informatika.org/k-01-11/graduit-be/src/module/dashboard_tim_ta/entity"

type DashboardTimUseCase interface {
	GetDataMahasiswa(offset, size int) (output []entity.DataPendaftaran, err error)
	GetStatusMahasiswa(offset, size int) (output []entity.StatusMahasiswa, err error)
}

type DashboardTimUc struct {
	dashboardTimRepo DashboardTimRepository
}

func NewDashboardTimUsecase(dashboardTimRepo DashboardTimRepository) *DashboardTimUc {
	return &DashboardTimUc{
		dashboardTimRepo: dashboardTimRepo,
	}
}

func (uc *DashboardTimUc) GetDataMahasiswa(offset, size int) (output []entity.DataPendaftaran, err error) {
	listMahasiswa, err := uc.dashboardTimRepo.GetDataDashboard(offset, size)

	if err != nil {
		return listMahasiswa, err
	}

	return listMahasiswa, nil
}

func (uc *DashboardTimUc) GetStatusMahasiswa(offset, size int) (output []entity.StatusMahasiswa, err error) {
	listMahasiswa, err := uc.dashboardTimRepo.GetStatusDashboard(offset, size)

	if err != nil {
		return listMahasiswa, err
	}

	return listMahasiswa, nil
}
