package usecase

import (
	"time"

	"gitlab.informatika.org/k-01-11/graduit-be/src/models"
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/pendaftaran/entity"
)

type PendaftaranRepository interface {
	NewPendaftaran(pendaftaran models.PendaftaranTA) (output models.PendaftaranTA, err error)
	GetPendaftaran() (output []models.PendaftaranTA, err error)
	DeletePendaftaran(id string) (models.PendaftaranTA, error)
	GetPendaftaranByIdDosen(id string) (output []models.PendaftaranTA, err error)
	SetStatus(id string, val string) (output []models.PendaftaranTA, err error)
	SetTimeInterview(id string, val time.Time) (output []models.PendaftaranTA, err error)
	GetPendaftaranByPeriode(idPeriode string) (output []models.PendaftaranTA, err error)
	GetPendaftaranById(id string) (output []entity.PendaftaranGetResponse, err error)
	GetRekapPendaftaranDosen(idDosen string) ([]entity.RekapPendaftaran, error)
	GetDetailRekapPendafataran(idDosen string, idMahasiswa string) (entity.DetailRekapPendaftara, error)
	UpdateInterview(interviewAt string, idDosen string, idMahasiswa string) error
	UpdateStatus(status string, idDosen string, idMahasiswa string) error
	CountApproved(idDosen string) (int64, error)
	CountProses(idDosen string) (int64, error)
	CountRejected(idDosen string) (int64, error)
	GetListofDosbing() ([]entity.Pengguna, error)
	CountApprovedAll() (int64, error)
	CountProsesAll() (int64, error)
	CountRejectedAll() (int64, error)
	GetDosbingName(idMahasiswa string) (string, error)
	GetAllPendaftaran() ([]entity.RekapPendaftaran, error)
	UpdateStatusById(status string, idPendaftaran string) error
	GetRiwayatPendaftaran(idMahasiswa string) ([]entity.RiwayatPendaftaran, error)
	GetDosbingForPendaftaran(idMahasiswa string) ([]entity.DosenPembimbing, error)
	GetAllDosbing() ([]entity.DosenPembimbings, error)
	UpdateDosbing(idDosbing string, idPendaftaran string) error
}
